%{
    #include <stdio.h>
    extern void yyerror(char*);
%}

%token BEGIN_OBJECT END_OBJECT COLON COMMA NUMBER STRING
%define parse.error verbose
%start object

%%

object : BEGIN_OBJECT optional_pair_list END_OBJECT ;

optional_pair_list : pair_list | %empty ;

pair_list : pair COMMA pair_list | pair ;

pair : STRING COLON value ;

value : STRING | NUMBER | object ;

%%

int main() {
    printf("Enter a Mini-JSON object!\n");
    yyparse();
    printf("Done.\n");
    return 0;
}

void yyerror(char *s) {
    printf("Incorrect. Error message: %s\n", s);
}

int yywrap(void) {
    return 1;
}
